<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <script>
            class MiBotonExtendido extends HTMLButtonElement{
                constructor(){
                    super();
                    this.addEventListener('click', (e) => {
                        console.log("evento click " + this.innerHTML);
                        alert('mi boton extendido');
                    });
                }
                static get ceName(){
                    return 'mi-boton-extendido';
                }
                get is (){
                    return this.getAttribute('is');
                }
                set is (value){
                    this.setAttribute('is',value || this.ceName);
                }
            }
            customElements.define('mi-boton-extendido',MiBotonExtendido,{extends:'button'});
        </script>
    <title>Custom Elements</title>
</head>
<body>
    <button is="mi-boton-extendido">es un boton extendido</button>
    <div id="container"></div>
    <script>
        const MiBotonExtendido2 =document.createElement('button',{is: MiBotonExtendido.ceName});

        MiBotonExtendido2.textContent = "Soy un  mi-boton-extendido2";
        document.body.appendChild(MiBotonExtendido2);

        const MiBotonExtendido3 =document.createElement('button', {is: MiBotonExtendido.ceName});
        MiBotonExtendido3.textContent = "Hola btn3";
        document.querySelector("#container").appendChild(MiBotonExtendido3);
    </script>
</body>
</html>